# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b428"
os.chdir("/Users/was/notebook/misc/worksheets/admin/122/cells/0")
sage.server.notebook.interact.SAGE_CELL_ID=0
def padic_cyclotomic_reconstruction(K, w, p, prec, phi):
    n = K.degree()
    zeta = K.gen()
    X = [zeta**i for i in range(n)] + [w]
    A = matrix(ZZ, n + Integer(2), n + Integer(2))
    for i in range(len(X)):
         A[i,i] = Integer(1)
         A[i,n+Integer(1)] = Mod(phi(X[i]), p**prec).lift()
    A[n+Integer(1), n+Integer(1)] = p**(prec-Integer(1))
    L = A.LLL()
    #print L
    rr = L[Integer(1)].copy()
    rr[Integer(0)] -= rr[-Integer(1)]
    alpha = -Integer(1)/rr[-Integer(2)]
    lin_comb = rr[:-Integer(2)]*alpha
    return K(lin_comb.list())

def solve_cyclo(A, v, prec=Integer(20), pstart=Integer(2)**Integer(10)):
    # solve A*x = v over cyclotomic number field
    K = A.base_ring()
    n = K.number_of_roots_of_unity()
    p = pstart
    while p % n != Integer(1):
        p = next_prime(p)
    print "p = ", p
    f = K.defining_polynomial()
    C = pAdicField(p, prec)
    R = f.roots(C)
    phi = K.hom(QQ(R[Integer(0)][Integer(0)].lift()), check=False)
    B = matrix(QQ, A.nrows(), A.ncols(), [phi(w) for w in A.list()])
    z = matrix(QQ, v.nrows(), v.ncols(), [phi(w) for w in v.list()])
    #return B.change_ring(ZZ), z.change_ring(ZZ)
    #print B
    __time__=misc.cputime(); __wall__=misc.walltime();  xx = B.solve_right(z) % p**prec; print         "Time: CPU %.2f s, Wall: %.2f s"%(misc.cputime(__time__), misc.walltime(__wall__))
    #print xx
    return matrix(K, xx.nrows(), xx.ncols(),
             [padic_cyclotomic_reconstruction(K, w, p, prec, phi) for w in xx.list()])

print "e428"
